package 
{
  import flash.display.BitmapData;
  import flash.display.Graphics;
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.geom.Matrix;
  import flash.geom.Point;
  import flash.geom.Rectangle;
  import flash.media.Sound;
  import flash.ui.Keyboard;
  import flash.utils.Dictionary;



	//[Frame(factoryClass="Preloader")]
	public class Main extends xGame 
	{

		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
  
    

    [Embed(source = "minifont8.png")]  private static var embedFontPic8:Class;
    [Embed(source = "minifont8.xfnt", mimeType = "application/octet-stream")]
    private static var embedFont8:Class;
    
    [Embed(source = "street.jpg")] private static var embedPicStreet:Class;
    [Embed(source = "ending.jpg")] private static var embedPicEnding:Class;
    [Embed(source = "man1_walk0.png")] private static var embedPicMan1Walk0:Class;
    [Embed(source = "man1_walk1.png")] private static var embedPicMan1Walk1:Class;
    [Embed(source = "man1_hit.png")]   private static var embedPicMan1Hit:Class;
    [Embed(source = "man1_attack.png")] private static var embedPicMan1Attack:Class;
    [Embed(source = "man1_ground.png")] private static var embedPicMan1Ground:Class;
    [Embed(source = "man2_walk0.png")] private static var embedPicMan2Walk0:Class;
    [Embed(source = "man2_walk1.png")] private static var embedPicMan2Walk1:Class;
    [Embed(source = "man2_hit.png")]   private static var embedPicMan2Hit:Class;
    [Embed(source = "man2_attack.png")] private static var embedPicMan2Attack:Class;
    [Embed(source = "man2_ground.png")] private static var embedPicMan2Ground:Class;
    
    [Embed(source = "nes.mp3")] private static var embedSndNes:Class;
    [Embed(source = "nes2.mp3")] private static var embedSndNes2:Class;
    [Embed(source = "hey.mp3")] private static var embedSndHey:Class;
    [Embed(source = "detroit.mp3")] private static var embedSndDetroit:Class;
    
   
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
      
      stage.quality = "LOW";
 
      myAdvFont = new xAdvFont();
      myAdvFont.loadFont(embedFont8, embedFontPic8);
      
      canvas = new BitmapData(640, 480, true, 0);
      
      dictPic["street"] = (new embedPicStreet).bitmapData;
      dictPic["ending"] = (new embedPicEnding).bitmapData;
      
      dictPic["man1walk0"] = (new embedPicMan1Walk0).bitmapData;
      dictPic["man1walk1"] = (new embedPicMan1Walk1).bitmapData;
      dictPic["man1hit"] = (new embedPicMan1Hit).bitmapData;
      dictPic["man1attack"] = (new embedPicMan1Attack).bitmapData;
      dictPic["man1ground"] = (new embedPicMan1Ground).bitmapData;
      
      dictPic["man2walk0"] = (new embedPicMan2Walk0).bitmapData;
      dictPic["man2walk1"] = (new embedPicMan2Walk1).bitmapData;
      dictPic["man2hit"] = (new embedPicMan2Hit).bitmapData;
      dictPic["man2attack"] = (new embedPicMan2Attack).bitmapData;
      dictPic["man2ground"] = (new embedPicMan2Ground).bitmapData;
      
       mySound2 = new xSoundMan();

      mySound2.dictSnd["nes"] = (new embedSndNes) as Sound;
      mySound2.dictSnd["nes2"] = (new embedSndNes2) as Sound;
      mySound2.dictSnd["hey"] = (new embedSndHey) as Sound;
      mySound2.dictSnd["detroit"] = (new embedSndDetroit) as Sound;

      
      
      stage.addEventListener(MouseEvent.MOUSE_DOWN, onMdown);
      stage.addEventListener(MouseEvent.MOUSE_UP, onMup);
      stage.addEventListener(KeyboardEvent.KEY_DOWN, onKdown);
      stage.addEventListener(KeyboardEvent.KEY_UP, onKup);
      stage.addEventListener(Event.ENTER_FRAME, onEnter);   
		}//init
   
    public var dictPic:Dictionary = new Dictionary();
    
    public function getData(str:String):BitmapData { return dictPic[str]; }
    
    public var mySound2:xSoundMan;
    public function playSound(wname:String, vm:Number = 1.0, pan:Number = 0.0):void 
    {  mySound2.playSound(wname, vm, 0);  }

  
    public var myAdvFont:xAdvFont;
    
    public var cx:Number = 160;
    public var cy:Number = 300;
    public var canJump:Boolean = false;
    public var vy:Number = 0;
    public var fireTime:int = 0;
    public var hitTime:int = 0;
    public var reload:int = 0;
    public var hp:Number = 100;
    
    public var gx:Number = 480;
    public var gy:Number = 300;
    public var gfireTime:int = 0;
    public var ghitTime:int = 0;
    public var ghp:Number = 100;
    
    public var wait:int = 5;

    public var gameState:int = 0;
    
    public function onEnter(e:Event):void
    {  
    
   
      if (ghp <= 0)
      { gameState += 1;   }
      
      if (gt == 100) { playSound("detroit");  }
      
      var ms:Number;
        ms = 32;
       if (gt % 4 == 0)
       {
         vy += 1;
         if (vy < -2) { cy -= ms; }
         if (vy > 0) { cy += ms; if (cy >= 300) { cy = 300; vy = 0; canJump = true; } }
         
         if (hp > 0)
         {
          if (isKeyDown(Keyboard.LEFT)) { cx -= ms; }
          if (isKeyDown(Keyboard.RIGHT)) { cx += ms; }
          if (isKeyDown(Keyboard.UP) && canJump) {  vy = -6; canJump = false; }
          if (isKeyDown(Keyboard.DOWN) && reload < gt)
          { reload = gt + 32; fireTime = gt + 24; }
         }//endif2
       }//endif
       
      graphics.clear();
        canvas.fillRect(canvas.rect, 0);
        myAdvFont.writeStr(canvas, 16, 16, "" + gt);
        
          drawImage(canvas, getData("street"),0,0);
        
//          drawSprite(canvas, getData("man1walk0"), 160, 300);
  //        drawSprite(canvas, getData("man2walk0"), 480, 300);
  
        var str:String;
        var i:int;
        i = int(cx / 64) % 2;
        str = "man1walk"+i;
        
        if (fireTime > gt || ghitTime>gt) { str = "man1attack"; }  
        if (hitTime > gt) { str = "man1hit"; }          
        if (hp <= 0) { str = "man1ground"; wait = 100; }

        
          drawSprite(canvas, getData(str), cx, cy);
          
        i = int(gx / 64) % 2;
        str = "man2walk"+i;  
        if (gfireTime > gt || hitTime>gt) { str = "man2attack"; }  
        if (ghitTime > gt) { str = "man2hit"; }          
        if (ghp <= 0) { str = "man2ground"; wait = 100; }
        drawSprite(canvas, getData(str), gx, gy);
        
        if (wait > 0) { wait -= 1; }
        else
        {
          wait = 4;
      //    i = getRand() * 32;
          i = Math.random() * 32;
          
          if (i < 8) { gx -= 32; if (gx < 320) { gx = 320; } }
          else if (i > 8 && i < 12) { gx += 32;  if (gx > 600) { gx = 600; }}
          
          if (i > 26) { gfireTime = gt + 32; wait = 50; }
        }//endif
        
        
        if (Math.abs(cx - gx) < 128 && cx < gx)
        {
          if (gfireTime > gt && fireTime > gt) { gfireTime = 0; fireTime = 0; }
          else if (fireTime > gt) { fireTime = 0; ghitTime = gt + 16; wait = 32; ghp -= 10; playSound("nes");  }  
          else if (gfireTime > gt) { gfireTime = 0; hitTime = gt + 16; wait = 32; hp -= 10; playSound("nes2");  }         
          
        }//endif
        
        
        
        
        var num:int;
        num = hp / 10;
        for (i = 0; i < num; i += 1)
        { fillRect(canvas, 8 + i * 16, 8, 12, 16, 0); }
        num = ghp / 10;
        for (i = 0; i < num; i += 1)
        { fillRect(canvas, 626 - (i * 16), 8, 12, 16, 0); }
        
        
        if (gameState > 100)
        { drawImage(canvas, getData("ending"), 0, 0);
          if (gameState==130){playSound("hey");  }
        }
        
        
        graphics.beginBitmapFill(canvas, null, false, false);
          graphics.drawRect(0, 0, 640, 480);
        graphics.endFill();
      canvas.unlock();
      canvas.lock();
      
      /*
      var ms:Number;
      graphics.lineStyle(2, 0);
        ms = 8;
        graphics.moveTo(mx, my - ms);
        graphics.lineTo(mx, my + ms);
        graphics.moveTo(mx-ms, my);
        graphics.lineTo(mx+ms, my);

*/
       gt += 1;
       keyTime += 1;
    }//onenter
    
    
   
  
 
  }//classend
}


